//----------------------------------------------------------------------//
// HTMLeLXgϊNX											//
//																		//
//----------------------------------------------------------------------//
#ifndef htmconvH
#define htmconvH

//---------------------------------------------------------------------------
#define DEF_LINE_WIDTH		80
#define DEF_BLANK_LN_LIMIT	5

//---------------------------------------------------------------------------
int check_UTF8(BYTE *bp, int size);
int get_MemoryCodePage(TMemoryStream *ms);
UnicodeString rel_to_abs(UnicodeString fnam, UnicodeString rnam);

//---------------------------------------------------------------------------
#define NO_CRSPC_PTN	"^(#{1,6}|\\s*[\\*\\+\\-]|\\s*\\d+\\.)\\s.+|^```"

//---------------------------------------------------------------------------
class HtmConv {
private:
	UnicodeString TxtLineBuf;
	TStringList *AlignList;
	bool Skip;
	bool fPRE, fXMP;
	int  BQ_level;

	void DelTagBlock(TStringList *lst, UnicodeString start_wd, UnicodeString end_wd);
	void DelAtrBlock(TStringList *lst, UnicodeString anam, UnicodeString aval);
	UnicodeString GetTagAtr(UnicodeString s, UnicodeString t, UnicodeString a);
	UnicodeString GetTag(UnicodeString s);
	void AddText(UnicodeString s);
	void FlushText();
	void AddLine(UnicodeString hrstr = EmptyStr, UnicodeString wdstr = EmptyStr, UnicodeString alstr = EmptyStr);

	void DecLevel(int &n)
	{
		n = std::max(n - 1, 0);
	}

public:
	HtmConv();
	~HtmConv();

	TStringList *HtmBuf;		//HTML̓obt@
	TStringList *TxtBuf;		//eLXgo̓obt@
	UnicodeString  TempDir;
	int OutCodePage;			//t@Cۑ̃R[hy[W

	bool ToMarkdown;			//Markdown L

	UnicodeString  FileName;	//̓t@C
	UnicodeString  FileTime;	//t@C̃^CX^v
	UnicodeString  UrlStr;		//URL
	UnicodeString  BaseStr;

	UnicodeString  HeadStr;		//wb_
	UnicodeString  FootStr;		//tb^
	UnicodeString  TitleStr;	//^Cg
	UnicodeString  StatMsg;		//Xe[^XbZ[W

	int  LineWidth;				//
	bool ForceCr;				//s
	int  BlankLnLimit;			//As
	bool NoPstHdr;				//o󂯂Ȃ
	UnicodeString HeaderStr[6];	//o
	UnicodeString HrLineStr;	//HRr
	UnicodeString IndentStr;	//Cfg
	UnicodeString UlMarkStr;	//}[N
	bool ZenNumber;

	bool UseAlt;				//֕ŕ\
	bool AddImgSrc;				//摜̃t@Ct
	UnicodeString DefAltStr;	//ftHg
	UnicodeString AltBraStr;	//摜 ͂
	UnicodeString AltKetStr;
	UnicodeString B_BraStr;		// ͂
	UnicodeString B_KetStr;
	UnicodeString I_BraStr;		//Α ͂
	UnicodeString I_KetStr;
	UnicodeString U_BraStr;		// ͂
	UnicodeString U_KetStr;
	UnicodeString CellSepStr;	//Z؂

	bool InsLink;				//N}
	bool OnlyExLink;			//ON̂
	bool AddCrLink;				//Oɉs
	UnicodeString LnkBraStr;	//N ͂
	UnicodeString LnkKetStr;

	UnicodeString InsLineStr;	//؂r
	UnicodeString InsHrClass;	//wNXDIV̑OɌr}
	bool InsHrSct;				//<section>̑OɌr}
	bool InsHrArt;				//<article>̑OɌr}
	bool InsHrNav;				//<nav>̑OɌr}

	UnicodeString DelBlkCls;	//폜 class Xg
	UnicodeString DelBlkId;		//폜 id Xg

	UnicodeString RefEntity(UnicodeString s);
	UnicodeString GetTitle(UnicodeString fnam);
	bool LoadFile(UnicodeString fnam);
	void Convert(TStringList *rep_lst = NULL);
	bool SaveToFileCP(UnicodeString fnam);
};
//---------------------------------------------------------------------------
#endif
